{TWavBitBtn
 Version 1.0.0
 By Victor Serrato
 E-mail virrato@yahoo.com

 This component can be freely used, besides you are invited to
 distribute it in commercial and private environments. I am sure of
 this component could be better, if you have any suggestion or you
 find any bug, please send me to virrato@yahoo.com.}

unit WavBitBtn;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons,  HDSFuncs;

type    
  TWaveBtnFiles = class(TWaveFiles)
  private
     FFocusEnter: TWaveFile;
     FFocusExit: TWaveFile;
     procedure SetWaveFile(Index: integer; NewWaveFile: TWaveFile);

  public
     constructor Create(AControl: TControl);
     procedure Assign(Source: TPersistent); override;
     procedure AssignTo(Dest: TPersistent); override;
     destructor Destroy; override;

  published
     property FocusEnter:TWaveFile index 0 read FFocusEnter write SetWaveFile;
     property FocusExit:TWaveFile index 1 read FFocusExit write SetWaveFile;
  end;

  TWavBitBtn = class(TBitBtn)
  private
     { Private declarations }
     FWaveFiles: TWaveBtnFiles;
     FOnMouseEnter: TNotifyEvent;
     FOnMouseExit: TNotifyEvent;

  protected
     { Protected declarations }
     procedure WMSetFocus(var Message: TMessage); message WM_SETFOCUS;
     procedure WMKillFocus(var Message: TMessage); message WM_KILLFOCUS;
     procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
     procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;

  public
    { Public declarations }
     constructor Create(AOwner: TComponent); override;
     destructor Destroy; override;
     procedure Click; override;

  published
    { Published declarations }
     property Align;
     property WaveFiles: TWaveBtnFiles read FWaveFiles write FWaveFiles;
     property OnMouseEnter: TNotifyEvent read FOnMouseEnter write FOnMouseEnter;
     property OnMouseExit: TNotifyEvent read FOnMouseExit write FOnMouseExit;
  end;

procedure Register;

implementation

//Implementation of the class TWaveBtnFiles
constructor TWaveBtnFiles.Create(AControl: TControl);
begin
   inherited Create(AControl);
   FFocusEnter:= TWaveFile.Create;
   FFocusExit:= TWaveFile.Create;
end;

destructor TWaveBtnFiles.Destroy;
begin
   FFocusEnter.Free;
   FFocusEnter:= nil;
   FFocusExit.Free;
   FFocusExit:= nil;
   inherited;
end;

procedure TWaveBtnFiles.Assign(Source: TPersistent);
begin
   if(Source is TWaveBtnFiles) then
      with TWaveBtnFiles(Source) do
      begin
         Self.FFocusEnter.Assign(FFocusEnter);
         Self.FFocusEnter.Assign(FFocusExit);
      end;

   inherited Assign(Source);
end;

procedure TWaveBtnFiles.AssignTo(Dest: TPersistent);
begin
   if(Dest is TWaveBtnFiles) then
      with TWaveBtnFiles(Dest) do
      begin
         Self.FFocusEnter.AssignTo(FFocusEnter);
         Self.FFocusEnter.AssignTo(FFocusExit);
      end;

   inherited AssignTo(Dest);
end;

procedure TWaveBtnFiles.SetWaveFile(Index: integer; NewWaveFile: TWaveFile);
begin
   case Index of
      0: FFocusEnter.Assign(NewWaveFile);
      1: FFocusExit.Assign(NewWaveFile);
   end;

   if(Assigned(OnChange)) then OnChange(Self);
end;

//Implementation of the class TWavBitBtn
constructor TWavBitBtn.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
   FWaveFiles:= TWaveBtnFiles.Create(Self);
end;

destructor TWavBitBtn.Destroy;
begin
   FWaveFiles.Free;
   inherited Destroy;
end;

procedure TWavBitBtn.Click;
begin
   inherited Click;
   FWaveFiles.Play(FWaveFiles.Click);
end;

procedure TWavBitBtn.WMSetFocus(var Message: TMessage);
begin
   inherited;
   FWaveFiles.Play(FWaveFiles.FocusEnter);
end;

procedure TWavBitBtn.WMKillFocus(var Message: TMessage);
begin
   inherited;
   FWaveFiles.Play(FWaveFiles.FocusExit);
end;

procedure TWavBitBtn.CMMouseLeave(var Message: TMessage);
begin
   inherited;
   if(Assigned(FOnMouseExit)) then FOnMouseExit(Self);
   FWaveFiles.Play(FWaveFiles.MouseExit);
end;

procedure TWavBitBtn.CMMouseEnter(var Message: TMessage);
begin
   inherited;
   if(Assigned(FOnMouseEnter)) then FOnMouseEnter(Self);
   FWaveFiles.Play(FWaveFiles.MouseEnter);
end;

procedure Register;
begin
  RegisterComponents('Hades', [TWavBitBtn]);
end;

end.
